package vip.xiaonuo.purchase.service;

import com.alibaba.fastjson.JSONArray;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import vip.xiaonuo.purchase.entity.PurchaseOrder;
import com.baomidou.mybatisplus.extension.service.IService;
import vip.xiaonuo.purchase.entity.vo.*;
import vip.xiaonuo.purchase.param.*;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * 采购订单表 服务类
 * </p>
 *
 * @author author
 * @since 2024-11-25
 */
public interface IPurchaseOrderService extends IService<PurchaseOrder> {

    //总览
    PurchaseOrderVo getOrder(PurchaseParam purchaseParam);

    //采购订单数量 金额
    List<PurchaseOrderMoneyVo> listOrderMoney(PurchaseOrderParam orderParam);

    //二级页面
    List<PurchaseOrderTypeVo> orderType(PurchaseParam param);

    //采购金额趋势
    List<PurchaseMoneyVo> listMoney(PurchaseParam param);

    //供应商占比分析
    JSONArray materialType(PurchaseParam param);

    PurchaseAllParam getIndicator(DongShiPurchaseParam priceParam);

    List<PurchaseAllParam> getCaiGouYvFuDetil(DongShiPurchaseParam priceParam);

    List<PurchaseAllParam> getCaiGouYvFuQuShi(DongShiPurchaseParam priceParam);

     List<PurchaseYuanCaiLiaoParam> getZhuYaoYuanCaiLiao(DongShiPurchaseParam priceParam);

    Page<GongYingShangParam> getGongYingShang(DongShiPurchaseParam priceParam);

    List<String > getWuLiaoShaiXuan(DongShiPurchaseParam priceParam);

    List<DongShiKuCunWuliaoVoParam > getKuCunWuLiao(DongShiKuCunWuliaoParam priceParam);
}
